using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class MelonArmorBehaviour : MonoBehaviour
    {
                private bool equipped;
        public string armorPiece;
        public int armorTier;
        public int SortingOrder;
        public float stabResistance;
        private bool blockingStab;
public float shrapnelChance;
public float initialAbsorb = -1;
        public Vector3 localScale;
        public Vector3 localPosition;

        public Vector3 localPosition2;

        public Vector3 localScale2;



        public string otherSprite;
        public string otherName;
        public string otherPiece;
        public float otherResist;
        public int otherTier;

        void Start()
        {
            GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
            
        }
        void Update()
        {
            if (equipped && GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>() && GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>().CurrentlyHolding)
            {
                GripBehaviour grip = GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>();
                Nocollide(grip.CurrentlyHolding.gameObject);
            }
        }

        private string[] Others = new string[]
        {
            "Stick",
            "Rod",
            "Hammer",
            "Wrench",
            "Flashlight",
            "Fire Extinguisher",
            "Baseball Bat",
            "Torch",
            "Stunner",
            "Sticky Grenade",
            "Chainsaw",
            "Beam Rifle",
            "Flamethrower",
            "Stielhandgranate",
            "Frame",
            "Handgrenade",
            "Grenade Launcher",
            "Energy Sword",
            "Reconstructor",
            "Rigidifier",
            "Rocket Launcher",
            "Scherbenwerfer",
            "Stormbaan",
            "Crossbow",
            "Spike Grenade"

         };
         
        private void OnCollisionEnter2D(Collision2D collision)
        {
            LimbBehaviour limb = collision.gameObject.GetComponent<LimbBehaviour>();
            MelonArmorBehaviour arm = collision.gameObject.GetComponent<MelonArmorBehaviour>();
            if (arm)
            {
                Nocollide(arm.gameObject);
            }
            if (limb)
            {
                Nocollide(limb.gameObject);
                // Bodypart sections are Torso, Head, Arms, and Legs
                // Bodyparts are UpperBody, MiddleBody, LowerBody etc.
                Debug.Log(limb.gameObject.ToString());
                Debug.Log(armorPiece);
                if (!equipped && limb.gameObject.ToString() == armorPiece + " (UnityEngine.GameObject)")
                {
                    Debug.Log("attach");
                    Attach(limb);
                }
            }
            if (equipped && collision.gameObject.GetComponent<Rigidbody2D>().velocity.x < stabResistance && !limb)
            {
                transform.parent = limb.transform;
                GetComponent<Rigidbody2D>().isKinematic = true;
                GetComponent<FixedJoint2D>().enabled = false;
            }
            else if (equipped)
            {
                transform.parent = null;
                GetComponent<Rigidbody2D>().isKinematic = false;
                GetComponent<FixedJoint2D>().enabled = true;
            }
                        if (collision.gameObject.GetComponent<FirearmBehaviour>() || collision.gameObject.GetComponent<CanShoot>())
            {
                Nocollide(collision.gameObject);
            }

            if (collision.gameObject.GetComponent<PhysicalBehaviour>().Properties.SharpAxes.Length > 0 || collision.gameObject.GetComponent<PhysicalBehaviour>().Properties.Sharp)
            {
                Nocollide(collision.gameObject);
            }
            
            foreach (string name in this.Others)
            {
                if (collision.gameObject.name == name)
                {
                    Nocollide(collision.gameObject);
                }
            }
        }
        private void OnCollisionExit2D(Collision2D collision)
        {
            if (GetComponent<Rigidbody2D>().isKinematic == true)
            {
                transform.parent = null;
                GetComponent<Rigidbody2D>().isKinematic = false;
                GetComponent<FixedJoint2D>().enabled = true;
            }
        }
        public void Nocollide(GameObject col)
        {
            NoCollide noCol = gameObject.AddComponent<NoCollide>();
            noCol.NoCollideSetA = GetComponents<Collider2D>();
            noCol.NoCollideSetB = col.GetComponents<Collider2D>();
        }
        public void Attach(LimbBehaviour limb)
        {
            
            SpriteRenderer sr = GetComponent<SpriteRenderer>();
            sr.sortingOrder = limb.gameObject.GetComponent<SpriteRenderer>().sortingOrder + /*2*/SortingOrder;
            sr.sortingLayerName = limb.gameObject.GetComponent<SpriteRenderer>().sortingLayerName;
            equipped = true;
            GetComponent<Rigidbody2D>().isKinematic = true;

transform.parent = limb.transform;
            if (limb.Person.GetComponent<ArmorBehaviourmeLON2>() == true)
            {
            
           /* transform.localEulerAngles = new Vector3(0, 0, 0);
            transform.localPosition = new Vector3(-0.0149f, 0f, 0f);
            transform.localScale = new Vector3(1.05f, 1f, 1f);
            */            
            transform.localEulerAngles = new Vector3(0, 0, 0);
                                        transform.localPosition = localPosition;
            transform.localScale = localScale; 
                          

            }
            else
            {
                        
            transform.localEulerAngles = new Vector3(0, 0, 0);
            transform.localPosition = localPosition2;
            transform.localScale = localScale2;                

            }



               transform.parent = null;
            FixedJoint2D joint = gameObject.AddComponent<FixedJoint2D>();
            joint.dampingRatio = 1;
            joint.frequency = 0;
            joint.connectedBody = limb.GetComponent<Rigidbody2D>();
            
  GetComponent<Rigidbody2D>().isKinematic = false;


        }
    }
    
   public class ArmorBehaviourmeLON2 : MonoBehaviour
    {

        void Start()
        {
//nothing lol
        }
        
}
}

